#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>     // Function: topper
#include <math.h>      // Function: sqrt

#include "graphics.h"

// Variaveis Globais

typedef struct {
                 char tipo;
                 int  x1,y1,x2,y2;     // Pontos P1(x1,y1) e P2(x2,y2)
                 int  r;               // Raio (para circulo)
                 int  c;               // Cor
               } t_primitivas;
               
t_primitivas *TP;                      // Ponteiro para Tabela de Primitivas (TP)
                                      // Tabela alocada dinamicamente
                                      
int MaxPrim;                          // Maximo de primitivas alocadas na tabela
int TotPrim;                          // Total  de primitivas lidas do arquivo
int CorFundo;                         // Cor de fundo da tela
int CorPrim;                          // Cor atual de desenho das primitivas

// Funcoes Externas
void initgraphics (void)
{
     initwindow(640,480); // Inicializa o modo grfico 640x480
}

void read_mouse (int *x, int *y)
{
     clearmouseclick(WM_LBUTTONDOWN);
     while (!ismouseclick(WM_LBUTTONDOWN))
     {
       *x=mousex();
       *y=mousey();
     }
}

// Mouse Functions
// void clearmouseclick( int kind );
// void getmouseclick( int kind, int& x, int& y );
// bool ismouseclick( int kind );
// int mousex( );
// int mousey( );
// WM_MOUSEMOVE        if you want to detect a mouse movement
// WM_LBUTTONDOWN         ...detect when the left mouse button is clicked down
// WM_LBUTTONUP           ...detect when the left mouse button is released up
// WM_RBUTTONDOWN         ...detect when the right mouse button is clicked down
// WM_RBUTTONUP           ...detect when the right mouse button is released up

//
// Rotina para leitura do Arquivo de Configurao: editor-cfg.txt
// Retorna: Sucesso ou Fracasso
// Retorna Parametros: nro. maximo de primitivas, cor de fundo, cor de primitiva
//
int le_arqcfg(int *maxp, int *corf, int *corp)
{
    FILE *arqcfg;
    int i;
    int  valor;
    char OkMax,OkCF,OkCP;
    char cmdlido[30];
    
    OkMax=OkCF=OkCP=0;
    arqcfg=fopen("editor-cfg.txt","rt");
    if (arqcfg == NULL)
    {
       printf(">> Erro na leitura do arquivo de configuracao!\n\n");
       return(0);
    }
    
    for (i=0; i<3; i++)
    {    
       fscanf(arqcfg,"%s %d",cmdlido,&valor);
       if (strcmp(cmdlido,"$MAXPRIM") == 0)
       {   *maxp=valor; OkMax=1;        }
       if (strcmp(cmdlido,"$CORFUNDO")== 0)
       {   if (valor >=0 && valor <= 255)
           *corf=valor; OkCF=1;         }
       if (strcmp(cmdlido,"$CORPRIM") == 0)
       {   if (valor >=0 && valor <= 255)
           *corp=valor; OkCP=1;         }
    }

    fclose(arqcfg);
    if (OkMax && OkCF && OkCP)
       return(1);
    else 
       return(0);
}

//
// Rotina para edicao interativa das primitivas
// Retorna: Total de Primitivas inseridas (TotPrim)
//
int editor_desenho(void)
{
    char resp[5];
    char prim;
    int valor;
    int raio;
    int tprim;
    int i;
    int p1x,p1y,p2x,p2y;
    
    initgraphics();
    
    tprim=0;
    while(1)
    {
       printf("Qual operacao deseha realizar (I,C,R,F): ");
       scanf("%s",resp);
       if ((resp[0]=='F') || (resp[0]=='f')) 
       {
          printf("Confirma Fim (S/N)? ");
          scanf("%s",resp);
          if ((resp[0]=='S') || (resp[0]=='s')) return(tprim);
       }
       if ((resp[0]=='C') || (resp[0]=='c')) 
       {
          printf("Cor - Selecione a nova cor das primitivas: ");
          scanf("%d",&valor);
          if ((valor>=0) && (valor<=255)) 
          {    CorPrim=valor;
               printf("Cor Selecionada: %d\n",CorPrim); }
          else printf(">> Cor invalida!\n");
       }
       if ((resp[0]=='R') || (resp[0]=='r'))
       {
           printf("Remover\n");
           printf("Use o mouse para selecionar os pontos...\n");
           read_mouse(&p1x,&p1y);
           printf("Selecionando ponto1:  X= %d Y= %d\n",p1x,p1y);
           for (i=0; i<tprim; i++)
               if ((p1x==TP[i].x1) && (p1y==TP[i].y1))
               {
                  if (TP[i].tipo != 'C')
                     printf("Removido: %c %d,%d,%d,%d,%d\n",TP[i].tipo,TP[i].x1,TP[i].y1,
                                                            TP[i].x2,TP[i].y2,TP[i].c);
                  else
                     printf("Removido: %c %d,%d,%d,%d\n",TP[i].tipo,TP[i].x1,TP[i].y1,
                                                            TP[i].r,TP[i].c);
                  TP[i].tipo='X';                   
               }   
       }
       if ((resp[0]=='I') || (resp[0]=='i'))
       {
          i=tprim;
          printf("Inserir - Qual tipo de primitiva (L, R, C): ");
          scanf("%s",resp);
          prim=toupper(resp[0]);
          printf("Use o mouse para selecionar os pontos...\n");
          read_mouse(&p1x,&p1y);
          printf("Selecionando ponto1:  X= %d Y= %d\n",p1x,p1y);
          read_mouse(&p2x,&p2y);
          printf("Selecionando ponto2:  X= %d Y= %d\n",p2x,p2y);
          if (prim=='C')  
          {
             raio=(int)sqrt((p2x-p1x)*(p2x-p1x)+(p2y-p1y)*(p2y-p1y));
             printf("Inserido: %c %d,%d,%d,%d,%d\n",prim,p1x,p1y,p2x,p2y,CorPrim);    
             setcolor(CorPrim);
             circle(p1x,p1y,raio);   
             TP[i].tipo='C';
             TP[i].x1=p1x; TP[i].y1=p1y; TP[i].x2=p2x; TP[i].y2=p2y; TP[i].r=raio; TP[i].c=CorPrim; 
             tprim++;      
          }
          if (prim=='L') 
          {
             printf("Inserido: %c %d,%d,%d,%d,%d\n",prim,p1x,p1y,p2x,p2y,CorPrim);
             setcolor(CorPrim);
             line(p1x,p1y,p2x,p2y);   
             TP[i].tipo='L';
             TP[i].x1=p1x; TP[i].y1=p1y; TP[i].x2=p2x; TP[i].y2=p2y; TP[i].c=CorPrim;
             tprim++;
          }
          if (prim=='R')
          {
             printf("Inserido: %c %d,%d,%d,%d,%d\n",prim,p1x,p1y,p2x,p2y,CorPrim);
             setcolor(CorPrim);
             rectangle(p1x,p1y,p2x,p2y);   
             TP[i].tipo='R';
             TP[i].x1=p1x; TP[i].y1=p1y; TP[i].x2=p2x; TP[i].y2=p2y; TP[i].c=CorPrim;
             tprim++;
          }
       }
    }
    return(tprim);
}

//
// Rotina para salvar as primitivas em disco
//
void salva_prim(int tprim)
{
   FILE *arqdraw;
   int i;
  
   arqdraw=fopen("desenho.txt","wt");
   if (arqdraw == NULL)
   {
       printf(">> Erro na escrita do arquivo de desenho!\n\n");
       system("Pause");
       exit(0);
   }
   
   for (i=0; i < tprim; i++)
   {
      if ((TP[i].tipo=='L') || (TP[i].tipo=='R'))
      {
         fprintf(arqdraw,"%c %d %d %d %d %d\n", TP[i].tipo, TP[i].x1,TP[i].y1,
                                                TP[i].x2,TP[i].y2, TP[i].c);
      }
      if (TP[i].tipo=='C')
      {
         fprintf(arqdraw,"%c %d %d %d %d\n", TP[i].tipo, TP[i].x1,TP[i].y1,
                                             TP[i].r, TP[i].c);
      }
      if (TP[i].tipo=='X')
      {
         // Nao faz nada... primitiva removida...
      }
   }
   fclose(arqdraw);  
}

//
// MAIN
//
int main(void)
{
    printf(">> ACME Power DrawEditor v1.0 <<\n");
    printf("\n");
    
    printf("Lendo Arquivo de Configuracao...\n");
    if (!le_arqcfg(&MaxPrim,&CorFundo,&CorPrim))
    {
       printf("Abortando execucao...\n"); 
       system("Pause");
       exit(0);
    }
    printf("Maximo de Primitivas: %d\n\n",MaxPrim);
    
    TP=(t_primitivas *)calloc(MaxPrim,sizeof(t_primitivas));
    TotPrim=0;
    
    printf("Editando Desenho...\n");
    TotPrim=editor_desenho();
    printf("\n");
    
    printf("Salvando Desenho...\n");
    salva_prim(TotPrim);
    printf("\n");
    
    system("PAUSE");
    return 1;
}
